<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="DoxyPress 1.2.10"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Commanders: D:/Mes documents/Trusty/Arduino/Libraries/Commanders/src/CANCommander.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="doxypress.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by DoxyPress -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Commanders
   </div>
   <div id="projectbrief">Arduino buttons/bus library</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by DoxyPress 1.2.10 -->
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('CANCommander_8hpp_source.html','');});
</script>
<div id="doc-content">
<div class="header">
  <div class="headertitle">
<div class="title">CANCommander.hpp</div>  </div>
  <div class="clear-floats"></div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="preprocessor">#ifndef __canCommander_H__</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#define __canCommander_H__</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;</div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &lt;<a class="code" href="Commanders_8h.html">Commanders.h</a>&gt;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef NO_CANCOMMANDER</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;</div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;mcp_can.h&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#define CANCommander CANCommanderClass::GetCurrent()</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00033"></a><span class="lineno"><a class="line" href="classCANCommanderClass.html">   33</a></span>&#160;<span class="keyword">class </span><a class="code" href="classCANCommanderClass.html">CANCommanderClass</a> : <a class="code" href="classCommander.html">Commander</a></div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;{</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;        <span class="keyword">static</span> <a class="code" href="classCANCommanderClass.html">CANCommanderClass</a> *pCANCommander;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;        MCP_CAN *pCan;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;        <span class="comment">// Global variables for reading and writing messages.</span></div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;        uint8_t IdR;                <span class="comment">// Id for CAN_recup()</span></div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> lenR = 0;     <span class="comment">// Current length of the messaga</span></div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> bufR[8];      <span class="comment">// Recieving buffer.</span></div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> bufS[8];      <span class="comment">// Sending buffer.</span></div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;        <span class="comment">// Global variables for the circular buffer.</span></div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> Circule[256]; <span class="comment">// Circular buffer for read messages, handled by interrupt.</span></div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;        <span class="keywordtype">int</span> indexW, indexR, Ncan;   <span class="comment">// Index of writing and reading buffer, and byte number to read.</span></div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;        uint8_t CANoverflow = 0;    <span class="comment">// flag overflow (buffer Circule full)</span></div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;        <span class="keywordtype">void</span> CAN_recup();</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00054"></a><span class="lineno"><a class="line" href="classCANCommanderClass.html#ad0e2b4faecea168636d7b36b390e465d">   54</a></span>&#160;        <span class="keyword">inline</span> <a class="code" href="classCANCommanderClass.html#ad0e2b4faecea168636d7b36b390e465d">CANCommanderClass</a>() : <a class="code" href="classCommander.html">Commander</a>() {}</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;        </div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        <span class="keywordtype">void</span> <a class="code" href="classCANCommanderClass.html#a192edd7c41059da4e7f201c4bb65684b">begin</a>(uint8_t inSPIpin, uint8_t inSpeed, uint8_t inInterrupt, uint16_t inId);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <a class="code" href="classCANCommanderClass.html#ac55b4d106afa8c09764931e287eb7c42">loop</a>();</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00092"></a><span class="lineno"><a class="line" href="classCANCommanderClass.html#af75894cb98a2442642de7f565a6d67f8">   92</a></span>&#160;        <span class="keyword">static</span> <span class="keyword">inline</span> <a class="code" href="classCANCommanderClass.html">CANCommanderClass</a> &amp;<a class="code" href="classCANCommanderClass.html#af75894cb98a2442642de7f565a6d67f8">GetCurrent</a>()</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        {</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            <span class="keywordflow">if</span> (pCANCommander == NULL)</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;                pCANCommander = <span class="keyword">new</span> <a class="code" href="classCANCommanderClass.html#ad0e2b4faecea168636d7b36b390e465d">CANCommanderClass</a>();</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <span class="keywordflow">return</span> *(CANCommanderClass::pCANCommander);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;        }</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;<span class="preprocessor">#ifdef COMMANDERS_PRINT_COMMANDERS</span></div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <span class="keyword">private</span>:</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        uint8_t SPIpin;</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;        uint8_t Speed;</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;        uint8_t Interrupt;</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;        uint16_t Id;</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;        <span class="keywordtype">void</span> printCommander();</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;};</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;<span class="comment">//-------------------------------------------------------------------</span></div><div class="ttc" id="classCANCommanderClass_html_af75894cb98a2442642de7f565a6d67f8"><div class="ttname"><a href="classCANCommanderClass.html#af75894cb98a2442642de7f565a6d67f8">CANCommanderClass::GetCurrent</a></div><div class="ttdeci">static CANCommanderClass &amp; GetCurrent()</div><div class="ttdef"><b>Definition:</b> <a href="CANCommander_8hpp_source.html#l00092">CANCommander.hpp:92</a></div></div>
<div class="ttc" id="classCANCommanderClass_html_ac55b4d106afa8c09764931e287eb7c42"><div class="ttname"><a href="classCANCommanderClass.html#ac55b4d106afa8c09764931e287eb7c42">CANCommanderClass::loop</a></div><div class="ttdeci">unsigned long loop()</div><div class="ttdef"><b>Definition:</b> <a href="CANCommander_8cpp_source.html#l00123">CANCommander.cpp:123</a></div></div>
<div class="ttc" id="classCANCommanderClass_html_a192edd7c41059da4e7f201c4bb65684b"><div class="ttname"><a href="classCANCommanderClass.html#a192edd7c41059da4e7f201c4bb65684b">CANCommanderClass::begin</a></div><div class="ttdeci">void begin(uint8_t inSPIpin, uint8_t inSpeed, uint8_t inInterrupt, uint16_t inId)</div><div class="ttdef"><b>Definition:</b> <a href="CANCommander_8cpp_source.html#l00030">CANCommander.cpp:30</a></div></div>
<div class="ttc" id="classCANCommanderClass_html_ad0e2b4faecea168636d7b36b390e465d"><div class="ttname"><a href="classCANCommanderClass.html#ad0e2b4faecea168636d7b36b390e465d">CANCommanderClass::CANCommanderClass</a></div><div class="ttdeci">CANCommanderClass()</div><div class="ttdef"><b>Definition:</b> <a href="CANCommander_8hpp_source.html#l00054">CANCommander.hpp:54</a></div></div>
<div class="ttc" id="classCommander_html"><div class="ttname"><a href="classCommander.html">Commander</a></div><div class="ttdef"><b>Definition:</b> <a href="Commander_8hpp_source.html#l00023">Commander.hpp:23</a></div></div>
<div class="ttc" id="classCANCommanderClass_html"><div class="ttname"><a href="classCANCommanderClass.html">CANCommanderClass</a></div><div class="ttdef"><b>Definition:</b> <a href="CANCommander_8hpp_source.html#l00033">CANCommander.hpp:33</a></div></div>
<div class="ttc" id="Commanders_8h_html"><div class="ttname"><a href="Commanders_8h.html">Commanders.h</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- Generated by DoxyPress 1.2.10 -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_d41d8cd98f00b204e9800998ecf8427e.html">src</a></li><li class="navelem"><b>CANCommander.hpp</b></li>
    <li class="footer">Generated on mer. oct. 18 2017 17:55:02 for Commanders &nbsp; by
    <a href="http://www.copperspice.com/documentation-doxypress.html">
    <img class="footer" src="doxypress.png" alt="DoxyPress"/></a> 1.2.10 </li>
  </ul>
</div>
</body>
</html>
